/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// MessageStatus the model 'MessageStatus'
type MessageStatus string

// List of MessageStatus
const (
	MESSAGE_STATUS_QUEUED MessageStatus = "queued"
	MESSAGE_STATUS_RETRYING MessageStatus = "retrying"
	MESSAGE_STATUS_ERROR MessageStatus = "error"
	MESSAGE_STATUS_ERROR_PROVIDER MessageStatus = "error_provider"
	MESSAGE_STATUS_SENT MessageStatus = "sent"
	MESSAGE_STATUS_DELIVERED MessageStatus = "delivered"
	MESSAGE_STATUS_READ MessageStatus = "read"
	MESSAGE_STATUS_PLAYED MessageStatus = "played"
	MESSAGE_STATUS_DELETED MessageStatus = "deleted"
)

// All allowed values of MessageStatus enum
var AllowedMessageStatusEnumValues = []MessageStatus{
	"queued",
	"retrying",
	"error",
	"error_provider",
	"sent",
	"delivered",
	"read",
	"played",
	"deleted",
}

func (v *MessageStatus) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := MessageStatus(value)
	for _, existing := range AllowedMessageStatusEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid MessageStatus", value)
}

// NewMessageStatusFromValue returns a pointer to a valid MessageStatus
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewMessageStatusFromValue(v string) (*MessageStatus, error) {
	ev := MessageStatus(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for MessageStatus: valid values are %v", v, AllowedMessageStatusEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v MessageStatus) IsValid() bool {
	for _, existing := range AllowedMessageStatusEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to MessageStatus value
func (v MessageStatus) Ptr() *MessageStatus {
	return &v
}

type NullableMessageStatus struct {
	value *MessageStatus
	isSet bool
}

func (v NullableMessageStatus) Get() *MessageStatus {
	return v.value
}

func (v *NullableMessageStatus) Set(val *MessageStatus) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageStatus) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageStatus) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageStatus(val *MessageStatus) *NullableMessageStatus {
	return &NullableMessageStatus{value: val, isSet: true}
}

func (v NullableMessageStatus) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageStatus) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

